/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package snake.strategies.simple;

import java.io.PrintStream;
import java.util.Scanner;
import snake.GameConstants;
import snake.communicator.Communicator;
import snake.communicator.NetClientCommunicator;
import snake.strategies.Strategy;

/**
 *
 * @author ivo
 */
public class SimpleStrategy implements Strategy {
    private Scanner in;
    private PrintStream out;
    private Field f;
    static final String[] DIRS = {"right","down", "left", "up"};
    
    
    @Override
    public void startGame(Communicator com) {
        in = com.in();
        out = com.out();
        String cmd = in.nextLine();
        if (!cmd.equals("START")) {
            throw new RuntimeException("START expected!");
        }
        // Read Field
        f = new Field(in);
        // current direction
        int d = 0;
        int points;
        while (true) {
            d=f.getDirection(d);
            out.println("MOVE "+DIRS[d]);
            out.flush();
            String state = in.nextLine();
            if (state.equals("ALIVE")) {
                points = in.nextInt();
                in.nextLine();
            } else if (state.equals("DEAD")) {
                points = in.nextInt();
                in.nextLine();
                String reason = in.nextLine();
                System.out.println("Died with "+points+" points.");
                System.out.println(reason);
                break;
            } else {
                String error = in.nextLine();
                System.out.println("ERROR: "+error);
                break;
            }
            f.update(in);
            System.out.format("%d points\n",points);
            System.out.print(f.toString());
        }
    }
    
    public static void main(String[] args) {
        Communicator c = new NetClientCommunicator("localhost", GameConstants.TCP_PORT);
        c.out().println("GAMES?");
        c.in().nextLine();
        int g = c.in().nextInt();
        System.out.println("We have "+g+" games.");
        c.in().nextLine();
        for (int i=0; i<g; i++) {
            System.out.println(c.in().nextLine());
        }
        c.out().println("JOIN\nPlain single");
        if (c.in().nextLine().equals("OK")) {
            c.in().nextLine();
            Strategy s = new SimpleStrategy();
            s.startGame(c);
        } else {
            System.out.println("Something went wrong.");
            System.out.println(c.in().nextLine());
        }
    }
    
}
